// CPVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CPVC.h"
#include "AddElement.h"
#include "CPVCDlg.h"
#include <list>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCPVCDlg dialog

CCPVCDlg::CCPVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCPVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCPVCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCPVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCPVCDlg)
	DDX_Control(pDX, IDC_OUTPUTDATA, m_cOutputData);
	DDX_Control(pDX, IDC_INPUTDATA, m_cInputData);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCPVCDlg, CDialog)
	//{{AFX_MSG_MAP(CCPVCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_UKLONI, OnUkloni)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCPVCDlg message handlers

BOOL CCPVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	
	DWORD dwStyle = LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	m_cInputData.SetExtendedStyle(dwStyle);
	m_cOutputData.SetExtendedStyle(dwStyle);

	SetColumns();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCPVCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCPVCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCPVCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCPVCDlg::SetColumns()
{
	CRect rect,rectout;
	m_cInputData.GetClientRect(&rect);
	int nColInterval = rect.Width()/3;

	m_cInputData.InsertColumn(0, _T("Dimenzija"), LVCFMT_LEFT, nColInterval*2);
	m_cInputData.InsertColumn(1, _T("Komada"), LVCFMT_LEFT, nColInterval);

	///////////////////////////////////////////////////////////////////////////

	m_cOutputData.GetClientRect(&rectout);
	m_cOutputData.InsertColumn(0, _T("Izlazni elementi"), LVCFMT_LEFT, rectout.Width());

}

void CCPVCDlg::OnAdd() 
{
	UpdateData();
if(m_dlgAddElement.DoModal()==IDOK)
{
theIterator = lista.begin(); //inicijalizacija iteratora
lista.insert(theIterator, m_dlgAddElement.m_iKomada, m_dlgAddElement.m_iDuzina);
theIterator = lista.begin();

	// Insert the first item
		lvi.mask = LVIF_TEXT;
		strItem.Format(_T("%d mm"),m_dlgAddElement.m_iDuzina);
		lvi.iItem = m_cInputData.GetItemCount();
		lvi.iSubItem = 0;
		lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);

		m_cInputData.InsertItem(&lvi);


		// Set subitem 1
		strItem.Format(_T("%d kom"),m_dlgAddElement.m_iKomada);
		lvi.iSubItem =1;
		lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);

		m_cInputData.SetItem(&lvi);

}	
}

void CCPVCDlg::CalcBest()
{
CString t;
strItem.Empty();

lista.sort();
lista.reverse();

list<int> lista_new;
list<int>::iterator newIterator;

list<int>::iterator poslednji;
list<int>::iterator temp=lista.begin();
list<int>::iterator pom;

bool check=false;

while(temp != lista.end()) 
{
	
poslednji=lista.end(); --poslednji;

if(GetSuma(lista_new)+*temp==10 || GetSuma(lista_new)+*temp<=10-*poslednji)
{
newIterator = lista_new.begin();
lista_new.insert(newIterator,*temp);
newIterator = lista_new.begin();
lista.erase(temp);
temp=lista.begin();
if(GetSuma(lista_new)>=10-*poslednji && GetSuma(lista_new)<=10) check=true;
}

else
{
++temp;
}

if(check==true)
{

	for( pom = lista_new.begin(); pom != lista_new.end();pom++) 
	{
		lvi.mask = LVIF_TEXT;
		t.Format("%d mm, ",*pom);
		strItem.Insert(strItem.GetLength(),t);
		lvi.iItem = m_cInputData.GetItemCount();
		lvi.iSubItem = 0;
		lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);
	}

	m_cOutputData.InsertItem(&lvi);
	
	strItem.Empty();
	t.Empty();
	lista_new.clear();
	check=false;
}


}
/*
for(pom=lista_new.begin();pom!=lista_new.end();pom++)
{
	t.Format("%d",*pom);
	MessageBox(t);
}
*/

//Kreni od pocetka niza i prebacuj elemente u novi niz ili listu ako im je suma jednaka konstanti
//ili <= od ( konstante - minimalni element ).

/*Postavice i jednu logicku promenljivu na false i proveravati je za slucaj da ne nade idealnu
kombinaciju i ponovi logiku sa doavanjem elemenata dok im je suma < 10.*/
}

void CCPVCDlg::OnUkloni() 
{
CalcBest();	
}

int CCPVCDlg::GetSuma(list<int> l)
{
	int suma=0;
	list<int>::iterator theIterator;

for( theIterator = l.begin(); theIterator != l.end();theIterator++) suma+=*theIterator;
return suma;
}
